
// Simple config parser library
//    2005 gama

#include <string.h>
#include <stdlib.h>

#include "config.h"

int ReadIntValue( const char *setting, configType *config )
{
    int i;

	// Sanity check
	if( config != NULL )
		for( i = 0; i < config->n_settings; i++ )
			if( !strcmp( setting, config->setting_list[i]->name ) )
				return atoi( config->setting_list[i]->val );

    return 0;
}

int ReadFreqValue( const char *setting, configType *config )
{
	return ReadIntValue(setting, config);
}

int ReadBoolValue( const char *setting, configType *config )
{
   return ReadIntValue(setting, config);
}

float ReadFloatValue( const char *setting, configType *config )
{
    int i;

	// Sanity check
	if( config != NULL )
		for( i = 0; i < config->n_settings; i++ )
			if( !strcmp( setting, config->setting_list[i]->name ) )
				return (float)atof( config->setting_list[i]->val );

    return 0.0f;
}

const char *ReadStringValue( const char *setting, configType *config )
{
    int i;

	// Sanity check
	if( config != NULL )
		for( i = 0; i < config->n_settings; i++ )
			if( !strcmp( setting, config->setting_list[i]->name ) )
				return config->setting_list[i]->val;

    return "<NULL>";
}
