
// Simple config parser library
//    2005 gama

#ifndef LIBCONFIG_H
#define LIBCONFIG_H

#ifdef __cplusplus
extern "C" {
#endif

typedef enum {
    TBOOL = 0x0,
    TINT,
    TFLOAT,
    TSTRING,
	TFREQ
} valType;

typedef struct Setting {
	const char *name;
    valType type;
    char *val;
    const char *def;
    const char *min;
    const char *max;
    const char *info;
} settingType;

typedef struct Config {
	settingType **setting_list;
	int n_settings;
} configType;

int 	ReadIntValue( const char *setting, configType *config );
int 	ReadFreqValue( const char *setting, configType *config );
int 	ReadBoolValue( const char *setting, configType *config );
float 	ReadFloatValue( const char *setting, configType *config );
const char  *ReadStringValue( const char *setting, configType *config );

#ifdef __cplusplus
}
#endif

#endif
