
// Simple utils library
//    2005 gama

#ifndef UTILS_H
#define UTILS_H

#include <pspiofilemgr.h>

#ifdef __cplusplus
extern "C" {
#endif

int is_ext(const char *s, const char *ext);
int is_zip(const char *s);
int is_playlist(const char *s);

char *get_filename( const char *path );
char *get_prefix_extension( const char *filename, int to_upper );
char *get_extension( const char *filename, int to_upper );
int is_prefix_extension( const char *filename, const char *ext );
int is_extension( const char *filename, const char *ext );
char *get_basename( const char *filename );
char *get_basedir( const char *filename );

int strcount(const char *s, char c);
char *itoa(int i, char *a, int r);

int _fgets(SceUID fd, char *line, int max_len);

/* Extra UTF8 Functions */
int utf8_strlen(const char *str);
void utf8_strncpy(char *dst, const char *src, int maxchars);
void utf8_strncat(char *dst, const char *src, int maxchars);
int utf8_offset(const char *str, int offset);

#ifdef __cplusplus
}
#endif

#endif
