/*
  KMZ80 common header
  by Mamiya
*/

#ifndef KMZ80_H_
#define KMZ80_H_

#include "kmtypes.h"
#include "kmevent.h"
#ifdef __cplusplus
extern "C" {
#endif

enum {
	REGID_B,
	REGID_C,
	REGID_D,
	REGID_E,
	REGID_H,
	REGID_L,
	REGID_F,
	REGID_A,
	REGID_IXL,
	REGID_IXH,
	REGID_IYL,
	REGID_IYH,
	REGID_R,
	REGID_R7,
	REGID_I,
	REGID_IFF1,
	REGID_IFF2,
	REGID_IMODE,
	REGID_NMIREQ,
	REGID_INTREQ,
	REGID_HALTED,
	REGID_M1CYCLE,
	REGID_MEMCYCLE,
	REGID_IOCYCLE,
	REGID_STATE,
	REGID_FDMG,
	REGID_MAX,
	REGID_REGS8SIZE = ((REGID_MAX + (sizeof(int) - 1)) & ~(sizeof(int) - 1))
};

typedef struct KMZ80_CONTEXT_TAG KMZ80_CONTEXT;
struct KMZ80_CONTEXT_TAG {
	u8 regs8[REGID_REGS8SIZE];
	u32 sp;
	u32 pc;
	/* ΢쥸 */
	u32 saf;
	u32 sbc;
	u32 sde;
	u32 shl;
	/* ƥݥե饰쥸(ۤΥ꡼ե饰) */
	u32 t_fl;
	/* ƥݥǡ쥸(ۤ35ե饰) */
	u32 t_dx;
	/* ޤǤ¸٤ */
	/* ƥݥץ५ */
	u32 t_pc;
	/* ƥݥꥪڥɥ쥸 */
	u32 t_op;
	/* ƥݥꥢɥ쥹쥸 */
	u32 t_ad;
	/* 륫 */
	u32 cycle;
	/* ڥɥơ֥ */
	void *opt;
	/* ڥCBơ֥ */
	void *optcb;
	/* ڥEDơ֥ */
	void *opted;
	/* ɲåơ֥ */
	void *cyt;
	/* R800꡼ڡ(ڡ֥쥤γǧ) */
	u32 mempage;
	/* üӳߥ٥ */
	u32 vector[5];
	/* RSTܥɥ쥹 */
	u32 rstbase;
	/* ɲåե饰 */
	/*   bit0: ۤΥ꡼ͭ */
	/*   bit1: ׵Ἣưꥢ */
	u32 exflag;
	/* Хå */
	u32 (*sysmemfetch)(KMZ80_CONTEXT *context);
	u32 (*sysmemread)(KMZ80_CONTEXT *context, u32 a);
	void (*sysmemwrite)(KMZ80_CONTEXT *context, u32 a, u32 d);
	/* 桼ǡݥ */
	void *user;
	/* 桼Хå */
	u32 (*memread)(void *u, u32 a);
	void (*memwrite)(void *u, u32 a, u32 d);
	u32 (*ioread)(void *u, u32 a);
	void (*iowrite)(void *u, u32 a, u32 d);
	u32 (*busread)(void *u, u32 mode);
	u32 (*checkbreak)(void *u, KMZ80_CONTEXT *context);
	u32 (*patchedfe)(void *u, KMZ80_CONTEXT *context);
	/* 桼٥ȥ */
	KMEVENT *kmevent;
};

void kmz80_reset(KMZ80_CONTEXT *context);
void kmr800_reset(KMZ80_CONTEXT *context);
void kmdmg_reset(KMZ80_CONTEXT *context);
u32 kmz80_exec(KMZ80_CONTEXT *context, u32 cycle);

#ifdef __cplusplus
}
#endif
#endif
