#ifndef XS_LENGTH_H
#define XS_LENGTH_H

//#include "xmms-sid.h"
#include <stdlib.h>
#include "xs_md5.h"

#ifdef __cplusplus
extern "C" {
#endif

#define XS_BUF_SIZE        	  (1024)
#define XS_SIDBUF_SIZE        (80*1024)

#define LPREV    (node->prev)
#define LTHIS    (node)
#define LNEXT    (node->next)

/* Types
 */
typedef struct _sldb_node_t {
    xs_md5hash_t    md5Hash;    /* 128-bit MD5 hash-digest */
    int            nlengths;   /* Number of lengths */
    int            *lengths;   /* Lengths in seconds */
    struct _sldb_node_t *prev, *next;
} sldb_node_t;


typedef struct {
    sldb_node_t     *nodes,
                    **pindex;
    size_t          n;
} xs_sldb_t;


/* Functions
 */
int            xs_sldb_read(xs_sldb_t *, const char *);
int            xs_sldb_index(xs_sldb_t *);
void            xs_sldb_free(xs_sldb_t *);
sldb_node_t *   xs_sldb_get(xs_sldb_t *, const char *);
sldb_node_t *   xs_sldb_get_rw(xs_sldb_t *, char *, int);

#ifdef __cplusplus
}
#endif
#endif /* XS_LENGTH_H */
